#
# McHalCK-cite-fishing.R,  3 Sep 22
#
# Data from:
# Google Scholar search result summary

library("colorspace")
library("plyr")


par(bty="l")
par(las=1)
par(pch="+")
pal_col=rainbow(4)


mh=read.csv("McHalCK-cite.csv")

# Gharm is citations of Dijkstra's go to letter
# AFP is citations for
# Software Function. Source Lines of Code, and Development Effort Prediction: A Software Science Validation.
# A. J. Albrecht and J. E. Gaffney. Jr.,

# Plot totals

plot(mh$year, mh$McCabe, log="y", col=pal_col[1],
	xlab="Year", ylab="Citations")

points(mh$year, mh$Halstead, col=pal_col[2])
points(mh$year, mh$CK, col=pal_col[3])
points(mh$year, mh$MOOD, col=pal_col[4])


# Plot annual totals

plot(tail(mh$year, -1), diff(mh$McCabe), log="y", type="l", col=pal_col[1],
	xaxs="i",
	ylim=c(1, 500),
	xlab="Year", ylab="Annual citations")

lines(tail(mh$year, -1), diff(mh$Halstead), col=pal_col[2])
lines(tail(mh$year, -1), diff(mh$CK), col=pal_col[3])
lines(tail(mh$year, -1), diff(mh$MOOD), col=pal_col[4])
# lines(tail(mh$year, -1), diff(mh$AFP), col=pal_col[5])

legend("topleft", legend=c("McCabe", "Halstead", "CK", "MOOD"),  # "Function points"),
                        fill=pal_col, border="white", bty="n")


dev.copy(dev=png, file="McHalCK-cite.png")
dev.off()

